//! \file    Main.cpp
//! \brief   Main function for visual_YAO.
//! \version 2010/06/17 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane.
/*
Copyright or  or Copr. Abdouramane MAYAKI

mail of the author: mayakiyerima@yahoo.fr

This software is a framework for variational data assimilation in
numerical models.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use,
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info".

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability.

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or
data to be ensured and,  more generally, to use and operate it in the
same conditions as regards security.

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/






/*
  Nom du Fichier: Main.cpp
  Nom de classe: Aucun
  Role: C'est la méthode principale (obligatoire) à partir de laquelle tout le programme est appelé.
  Nombre de methodes appelées:
  Nombre d'attributs globaux:
  Nombre de fichiers inclus: (1) du système et (13) personnalisés
  */

#include <QApplication>
#include <QTextCodec>
#include <cstdlib>
#include <exception>
#include "src/include/MainWindow.hpp"
//#include "src/include/MainWindowController.hpp"
//#include "BasicWindow.hpp"
//#include <iostream>

/*
  Nom du Fichier: Main.cpp
  Nom de classe: Aucun
  Role: C'est la méthode principale (obligatoire) à partir de laquelle tout le programme est appelé.
  Nombre de methodes appelées:
  Nombre d'attributs globaux:
  Nombre de fichiers inclus: (1) du système et (13) personnalisés
  */


//using namespace std;

int main(int argc, char *argv[]) {

	QApplication app(argc, argv);

	QTextCodec::setCodecForCStrings(QTextCodec::codecForName("UTF-8"));

	try {
		MainWindow fen1;//  = new MainWindow(&m_mwc); //fen1->show();
		fen1.show();
		
		return app.exec();

		//fen1->~MainWindow();
		//m_mwc.~MainWindowController();

	}           
	catch(...) 
	{
   
           cout << "exception dans le main" << endl;
        }
}

