#ifndef MAINWINDOWCONTROLLER_HPP
#define MAINWINDOWCONTROLLER_HPP

#include "../../../help/Enforcer.hpp"
#include "../../../help/FilePath.hpp"
#include <string>

#include "ConnectionWindow.hpp"
//#include "ConstantWindow.hpp"
#include "FilesViewer.hpp"
#include "HatNameWindow.hpp"
#include "InsertFCTWindow.hpp"
//#include "ModulWindow.hpp"
#include "NetwardWindow.hpp"
//#include "NewProjectWindow.hpp"
#include "SpaceController.hpp"
#include "SpaceWindow.hpp"
//#include "TrajController.hpp"
#include "TrajectoryWindow.hpp"
#include "OperaWindow.hpp"
//#include "ContextWindow.hpp"
#include "OrderWindow.hpp"
#include "../YAOObjects/Table.hpp"
//#include "MainWindow.hpp"
#include <QMessageBox>

class MainWindowController {

	public :

		//static MainWindowController(std::string as="") & getInstance();
                MainWindowController();
		//ConstantWindow *getConstant();
                void setConstant();
		template <class T> T Min(T x, T y){
		
		return x<y ? x:y; 

		}
		//template <class R, class S, class T> void addRowInTable(R, S, T) {

		// modele->setItem(modele->rowCount(), 0, new QStandardItem(m_ligneNom->text()));

		//}
                void setFileListController(std::string fileController);
                std::string getProjectNameFromMWC();

                void setProjectNameInMWC(std::string projectName);

                void setTheHeaderList(string theHeaderListSring);

                std::vector<std::string> getTheHeaderList();
                void setFileListController();

                ConnectionWindow *getCtin();
                HatNameWindow *getHatName();
                InsertFCTWindow *getInsertFCT();
                //ModulWindow *getModul();
                NetwardWindow *getNetward();
                OrderWindow *getOrder();
                OperaWindow *getOpera();
                //ContextWindow *getContext();
                //SpaceWindow *getSpace();
                TrajectoryWindow *getTraj();

                //void getNewProjectInstance();
                //void getNP();

                SpaceController getSpaceController();

                yao::Table<yao::Trajectory> getTheTrajectoryTable();
		bool isIdentifier(std::string aString);
		bool isStringLiteral(std::string aString);
		bool isIntegerLiteral(std::string aString);
		bool isExponent(std::string aString);

		~MainWindowController();	
        private :

		//MainWindowController() ;//{}

                //ConstantWindow *m_Constant;
                ConnectionWindow *m_ctin;
                FilesViewer *m_directoryViewer;
                HatNameWindow *m_hat;
                InsertFCTWindow *m_insertFCT;
                //ModulWindow *m_modul;
                NetwardWindow *m_netward;
                //NewProjectWindow *np;
                OrderWindow *m_order;
                OperaWindow *m_opera;
                //ContextWindow *m_Context;
                TrajectoryWindow *m_traj;
                SpaceController *m_spc;
                SpaceWindow *m_space;
                std::string m_projectNameInMWC;  // MWC = MainWindowController

                std::vector<std::string> m_theHeaderList;
                yao::Table<yao::Trajectory> m_theTrajectoryTable;
		bool npTest;
            };

#endif // MAINWINDOWCONTROLLER_HPP
