#ifndef FILESVIEWER_HPP
#define FILESVIEWER_HPP

#include <QDialog>

class QDirModel;
class QPushButton;
class QTreeView;

class FilesViewer : public QDialog
{
    Q_OBJECT

	public:

		FilesViewer(std::string projectPath="projects/", QWidget *parent = 0);//The projectPath is initialized with project/ by default.
		void updateTheView();


	public slots:

		void createDirectory();
		void removeFilesOrDirectory();

	private:

		QTreeView *vueFichiers;
		QDirModel *modeleFichiers;
		QPushButton *mkdirButton;
		QPushButton *removeButton;
		QPushButton *boutonActualiser;

};

#endif //ARBOFICHIERS_HPP
