/*
  Nom du Fichier: NewProjectWindow.hpp
  Nom de classe: NewProjectWindow
  Role:
  Functions:
  Attributs:
  */

#ifndef NEWPROJECTWINDOW_HPP
#define NEWPROJECTWINDOW_HPP

#include <cstring>
#include <exception>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <QWorkspace>
#include "../../ui_newprojectwindow.h"
#include <QDir>
#include <QFileDialog>
#include <QMessageBox>
//#include <QStandardItemModel>

class NewProjectWindow : public QDialog, public Ui::NewProjectWindow {

	Q_OBJECT

	public :
		NewProjectWindow(QWorkspace &espace, QDialog *parent=0);
		NewProjectWindow(QDialog *parent=0);
		void setProjectName(std::string aProjectName);
		std::string getProjectName();
		void setProjectPath(std::string aProjectPath); //Fonction permettant d'initialiser le chemin du projet.
		std::string getProjectPath();

	private slots:

		void openPathWindow(); 
		void helpMessage();
		void createProjectDirectory();
		
	signals:
		//void orderWindowIsClosed(int );
		void projectDone();

	protected:
		//void closeEvent(QCloseEvent *event);
		void createFile(std::string data, std::string extension);
		void generateDefaultHFile();

	private :
		std::string m_newProjectWindowProjectName;
		std::string m_newProjectWindowProjectPath;
		 //QStandardItemModel *m_orderModel;
};
#endif // NEWPROJECTWINDOW_HPP
